/*
			Copyright (c) 1994 by
			Advanced Visual Systems Inc.
			All Rights Reserved

	This software comprises unpublished confidential information of
	Advanced Visual Systems Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.

	This file is under Perforce control
	$Id: //depot/express/fcs992/include/avs/strmio.h#1 $
*/
#ifndef _IO_INCLUDED
#define _IO_INCLUDED

#include <stdio.h>
#include <avs/port.h>

#define IO_STREAM_BUFSIZE 	2048

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _IO_file_stream {
    FILE *fp;
} IO_file_stream;

typedef struct _IO_mem_stream {
    char *ptr;
    int size_alloced;
    int size_used;
} IO_mem_stream;

#define IO_STREAM_FP	1
#define IO_STREAM_MEM 	2

typedef struct _IOstream {
    int type;
    union {
       IO_file_stream fs;
       IO_mem_stream ms;
    } v;
    unsigned int trigger:1;
    char *trigger_buf;
    int trigger_size;
} IOstream; 

IOstream *IOstream_file_open PTARGS((char *file));
IOstream *IOstream_file_append PTARGS((char *file));
IOstream *IOstream_mem_open PTARGS((void));
int IOstream_mem_compare PTARGS((IOstream *stream, char *file));
int IOstream_mem_write PTARGS((IOstream *stream, char *file));
void IOstream_close PTARGS((IOstream *stream));
void IOstream_flush PTARGS((IOstream *stream));

void IOstream_triggered_output PTARGS((IOstream *stream,...));
int IOstream_trigger_cancel PTARGS((IOstream *stream));

void IOstream_output PTARGS((IOstream *stream,...));
char * IOint_to_str PTARGS((int ival, char *buf));

#ifdef __cplusplus
} /* end of extern C */
#endif

#endif 
